#ifndef _GRAY_WORLD_H

#define _GRAY_WORLD_H

#include <cmath>

#if defined(_WIN32) || defined(_WIN64)
#include <cv.h>
#include <highgui.h>
#else
#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/highgui/highgui.hpp>
#endif

class GrayWorld{
public:
	static cv::Scalar PerformGeneralIlluminationEstimation(double &result, cv::Mat source, int order=0, double sigma=0, int norm=1, int median=1, int shrink=0);
	static void ImageGaussianDerivative(cv::Mat source, cv::Mat &destination, double sigma, int order=0);
private:
	GrayWorld();
	~GrayWorld();
	static void ChannelGaussianDerivative(cv::Mat source, cv::Mat &destination, double sigma, int di, int dj);
};

#endif
